/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package calc_complejos;

import complejos.complejo;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.util.Enumeration;
import java.util.Vector;

/**
 *
 * @author krios
 */
public class visorcomplejos extends Canvas {

    Vector complejos;
    int numcolor;
    final Color[] paleta = {Color.BLUE, Color.GREEN, Color.MAGENTA, Color.YELLOW, Color.BLACK};

    public visorcomplejos() {
        complejos = new Vector(3, 1);
        numcolor = 0;
    }
    //Constructor recibe el complejo a representar:

    @Override
    public Dimension getPreferredSize() {
        return new Dimension(250, 250);
    }

    public void aniadir(complejo nuevo, String nombre) {
        //try{
        boolean add = complejos.add(new complejo(nuevo, paleta[numcolor++], nombre));
       // }catch(){
       // JOptionPane.showMessageDialog(null, "Error al represenar complejo", "Aviso", JOptionPane.ERROR_MESSAGE);
      //  }
    }

    private double mayormodulo() {
        complejo mayor, comparado;
        Enumeration i = complejos.elements();
        mayor = (complejo) i.nextElement();//el primero es el mayor por defecto

        while (i.hasMoreElements()) {
            comparado = (complejo) i.nextElement();
            if (mayor.modulo() < comparado.modulo()) {
                mayor = comparado;
            }
        }
        return mayor.modulo();

    }

    // Este el el método de verdad que pinta, y lo hace cada vez que
    // el AWT le indica que lo haga
    @Override
    public void paint(Graphics g) {
        double escala;
        final int margen=10;

        // Calculamos dinámicamente todos los tamaños, de forma que
        // el canvas se puede cambiar externamente
        // La circunferencia siempre utiliza
        // como dimensión para el diámetro la dimensión más pequeña
        // de la ventana en que se encuentra
        Dimension tamano = getSize();
        // Calculamos el diámetro total de la circunferencia
        int diam = Math.min(tamano.width, tamano.height);
        // Fijamos el diámetro de los ojos a un décimo del de la cara 
        int maxeje = (diam / 2)-margen;
        // Calculamos el centro
        int x = (tamano.width - diam) / 2;
        int y = (tamano.height - diam) / 2;

        // Pintamos una circunferencia
        g.setColor(Color.gray);

        //g.fillOval( x,y,diam,diam );    
        //Pintamos el perimetro:
        g.drawOval(x, y, diam, diam);

        //PINTAMOS LOS EJES:
        g.setColor(Color.darkGray);
        // vertical (eje Imaginario):
        g.drawLine(tamano.width / 2, 0, tamano.width / 2, tamano.height);
        g.drawString("Im", (tamano.width / 2)+5, +20);
        // horizontal (eje Real):
        g.drawLine(0, tamano.height / 2, tamano.width, tamano.height / 2);
        g.drawString("Re", tamano.width-20, (tamano.height/2)-5);

        //cambio de origen de coordenadas:
        g.translate(tamano.width / 2, tamano.height / 2);
        //pintamos el complejo
        escala = maxeje / mayormodulo();
        Enumeration i = complejos.elements();
        while (i.hasMoreElements()) {
            complejo apintar = (complejo) i.nextElement();
            apintar.pintar(g, escala);
        }



    /*// Pintamos los dos ojos de la carita
    g.fillOval( x+diam/3-(diamOjo/2),y+diam/3-(diamOjo/2), 
    diamOjo,diamOjo );
    g.fillOval( x+(2*(diam/3))-(diamOjo/2),y+diam/3-(diamOjo/2), 
    diamOjo,diamOjo );
    
    // Pintamos la boca de la carita
    g.drawArc( x+diam/4,y+2*(diam/5),diam/2,diam/3,0,-180 );*/

    }
}
